/***************************************************************
/  Ifcaro3D - Preview                                          /
/                                                              /
/  Creado por Ifcaro <taslokooo@gmail.com>                     /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Contiene codigo de ps2game:                                 /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include <kernel.h>
#include <sifrpc.h>
#include <loadfile.h>

// llibPlanar
#include "LlibPlanar.h"

// ODE
#include "ode.h"
#include "capa2d.h"
#include "capa3d.h"

// AudioLib
#include "audiolib.h"
#include "audiolibmp3.h"

// PAD
#include "libpad.h"

#define PAD_L3_LEFT   0x0018
#define PAD_L3_RIGHT  0x0014
#define PAD_L3_UP     0x0012
#define PAD_L3_DOWN   0x0011
#define PAD_R3_LEFT   0x0108
#define PAD_R3_RIGHT  0x0104
#define PAD_R3_UP     0x0102
#define PAD_R3_DOWN   0x0101

 
// ----- SYSTEM GFX ----- //

    #define GFX_PAL   1 // 640 x 512
    #define GFX_NTSC  2 // 640 x 448
    #define GFX_AUTO  3 // Autodetect PAL vs NTSC

 
void Graphics(int mode, char *argv);
int GraphicsMode();
int GraphicsIsPal();
int GraphicsIsNtsc();
int GraphicsWidth();
int GraphicsHeight();
void Flip();
// ----- SYSTEM SFX ----- //

	//void SysInitSFX(char *audioirx);
	void SysInitSFX();
	void SysResetSFX();
	void SysTickSFX();

	int LoadMusic(char *filename);
	int LoadMusicC(char *filename, int size);
	void PlayMusic(int id,int loop);
	void PauseMusic();
	void StopMusic();
	void FreeMusic(int id);
	int MusicPlaying();

	int LoadSound(char *filename, int duracion);
	int LoadSoundC(char *filename, int size, int duracion);
	void PlaySound(int id);

// ----- SYSTEM PAD ----- //

typedef struct
    {
    int port;
    int slot;
    int connected;
    
   	u32 paddata;
   	u32 oldpaddata;
   	char *padBuf;
   	
   	struct padButtonStatus buttons;

   	unsigned char tick[24];
   	unsigned char tickCount[24];

   	char LEFT, DOWN, RIGHT, UP;
   	char START,SELECT;
   	char R1,R2,R3;
   	char L1,L2,L3;
   	char SQUARE, CROSS, CIRCLE, TRIANGLE;
	char R3_LEFT, R3_RIGHT, R3_UP, R3_DOWN;
	char L3_LEFT, L3_RIGHT, L3_UP, L3_DOWN;	
    } padData;


    padData *SysInitPad(int port,int slot);
    void SysPadResetControl(padData *data);
    void SysPadSetControl(padData *data,int button,int iterator);
    void SysPadGetData(padData *data);
    void SysPadSetEngine(padData *data,int SmallEngine, int BigEngine);

padData *pad;

// ----- SYSTEM GAME ----- //
	void SysGameStart();
	int SysGameStatus();
	int SysGameIsStatus(int modo);
	void SysGameRegister(int id, void (*ProcStart)(), 
 								 void (*ProcTick)(), 
          						 void (*ProcStop)());
	void SysGameChangeTo(int mode);
	void SysGameTick();

char* minusculas(char* texto);
char* substr(char* cadena, int comienzo, int longitud);
