#ifndef __TAGS_H_
#define __TAGS_H_
// OTHER: NEEDS FOR THE LIB structs


//gifTag
typedef struct {
	 u_long128 NLOOP:15;	// repeat count
	 u_long128 EOP  :1;	// end of packet
	 u_long128 pad0 :30;	// padding
	 u_long128 PRE  :1;	// prim field enable
	 u_long128 PRIM :11;	// prim field
	 u_long128 FLG  :2;	// data format
	 u_long128 NREG :4;	// number of register descriptors in reg field
	 u_long128 REGS :64;	// register descriptors
} stgifTag;
// gifTag SET macro
#define LIB_SET_gifTag(NLOOP, EOP, PRE, PRIM, FLG, NREG, REGS) \
	(((u_long)(NLOOP) << 0)      | ((u_long)(EOP) << 15)       |\
	 ((u_long)(PRE) << 46)       | ((u_long)(PRIM) << 47)      |\
	 ((u_long)(FLG) << 58)       | ((u_long)(NREG) << 60)      |\
	 ((u_long)(REGS) << 64))
#define gifTag_NLOOP_M	(0x7FFF<<0)
#define gifTag_EOP_M	(0x1<<15)
#define gifTag_PRE_M	(0x1<<46)
#define gifTag_PRIM_M	(0x7FF<<47)
#define gifTag_FLG_M	(0x3<<58)
#define gifTag_NREG_M	(0xF<<60)
#define gifTag_REGS_M	(0xFFFFFFFFFFFFFFFF<<64)

#define gifTag_NLOOP_O	(0)
#define gifTag_EOP_O	(15)
#define gifTag_PRE_O	(46)
#define gifTag_PRIM_O	(47)
#define gifTag_FLG_O	(58)
#define gifTag_NREG_O	(60)
#define gifTag_REGS_O	(64)
// gifTag instances



//dmaTag
typedef struct {
	 u_long QWC :16;	// quadword count
	 u_long pad0:10;	// padding
	 u_long PCE :2;	// priority control enable
	 u_long ID  :3;	// tag id
	 u_long IRQ :1;	// interrupt request
	 u_long ADDR:31;	// address
	 u_long SPR :1;	// memory/spr selection
} stdmaTag;
// dmaTag SET macro
#define LIB_SET_dmaTag(QWC, PCE, ID, IRQ, ADDR, SPR) \
	(((u_long)(QWC) << 0)       | ((u_long)(PCE) << 26)      |\
	 ((u_long)(ID) << 28)       | ((u_long)(IRQ) << 31)      |\
	 ((u_long)(ADDR) << 32)     | ((u_long)(SPR) << 63))
#define dmaTag_QWC_M	(0xFFFF<<0)
#define dmaTag_PCE_M	(0x3<<26)
#define dmaTag_ID_M	(0x7<<28)
#define dmaTag_IRQ_M	(0x1<<31)
#define dmaTag_ADDR_M	(0x7FFFFFFF<<32)
#define dmaTag_SPR_M	(0x1<<63)

#define dmaTag_QWC_O	(0)
#define dmaTag_PCE_O	(26)
#define dmaTag_ID_O	(28)
#define dmaTag_IRQ_O	(31)
#define dmaTag_ADDR_O	(32)
#define dmaTag_SPR_O	(63)
// dmaTag instances


#endif
//
