#ifndef __VIF_H_
#define __VIF_H_
// VIF REGISTERS structs


//VIFn_Rx
typedef struct {
	 u_int R:32;	// row data for filling when decompressing
} stVIFn_Rx;
// VIFn_Rx SET macro
#define LIB_SET_VIF0_R0	LIB_SET_VIFn_Rx
#define LIB_SET_VIF0_R1	LIB_SET_VIFn_Rx
#define LIB_SET_VIF0_R2	LIB_SET_VIFn_Rx
#define LIB_SET_VIF0_R3	LIB_SET_VIFn_Rx
#define LIB_SET_VIF1_R0	LIB_SET_VIFn_Rx
#define LIB_SET_VIF1_R1	LIB_SET_VIFn_Rx
#define LIB_SET_VIF1_R2	LIB_SET_VIFn_Rx
#define LIB_SET_VIF1_R3	LIB_SET_VIFn_Rx
#define LIB_SET_VIFn_Rx(R) \
	(((u_long)(R) << 0))
#define VIFn_Rx_R_M	(0xFFFFFFFF<<0)

#define VIFn_Rx_R_O	(0)
// VIFn_Rx instances
#define VIF0_R0 	((volatile u_int *)(0x10003900))
#define VIF0_R1 	((volatile u_int *)(0x10003910))
#define VIF0_R2 	((volatile u_int *)(0x10003920))
#define VIF0_R3 	((volatile u_int *)(0x10003930))
#define VIF1_R0 	((volatile u_int *)(0x10003d00))
#define VIF1_R1 	((volatile u_int *)(0x10003d10))
#define VIF1_R2 	((volatile u_int *)(0x10003d20))
#define VIF1_R3 	((volatile u_int *)(0x10003d30))



//VIFn_Cx
typedef struct {
	 u_int C:32;	// column data for filling when decompressing
} stVIFn_Cx;
// VIFn_Cx SET macro
#define LIB_SET_VIF0_C0	LIB_SET_VIFn_Cx
#define LIB_SET_VIF0_C1	LIB_SET_VIFn_Cx
#define LIB_SET_VIF0_C2	LIB_SET_VIFn_Cx
#define LIB_SET_VIF0_C3	LIB_SET_VIFn_Cx
#define LIB_SET_VIF1_C0	LIB_SET_VIFn_Cx
#define LIB_SET_VIF1_C1	LIB_SET_VIFn_Cx
#define LIB_SET_VIF1_C2	LIB_SET_VIFn_Cx
#define LIB_SET_VIF1_C3	LIB_SET_VIFn_Cx
#define LIB_SET_VIFn_Cx(C) \
	(((u_long)(C) << 0))
#define VIFn_Cx_C_M	(0xFFFFFFFF<<0)

#define VIFn_Cx_C_O	(0)
// VIFn_Cx instances
#define VIF0_C0 	((volatile u_int *)(0x10003940))
#define VIF0_C1 	((volatile u_int *)(0x10003950))
#define VIF0_C2 	((volatile u_int *)(0x10003960))
#define VIF0_C3 	((volatile u_int *)(0x10003970))
#define VIF1_C0 	((volatile u_int *)(0x10003d40))
#define VIF1_C1 	((volatile u_int *)(0x10003d50))
#define VIF1_C2 	((volatile u_int *)(0x10003d60))
#define VIF1_C3 	((volatile u_int *)(0x10003d70))



//VIFn_CYCLE
typedef struct {
	 u_int CL  :8;	// cycle length
	 u_int WL  :8;	// write cycle length
	 u_int pad0:16;	// padding
} stVIFn_CYCLE;
// VIFn_CYCLE SET macro
#define LIB_SET_VIF0_CYCLE	LIB_SET_VIFn_CYCLE
#define LIB_SET_VIF1_CYCLE	LIB_SET_VIFn_CYCLE
#define LIB_SET_VIFn_CYCLE(CL, WL) \
	(((u_long)(CL) << 0)    | ((u_long)(WL) << 8))
#define VIFn_CYCLE_CL_M	(0xFF<<0)
#define VIFn_CYCLE_WL_M	(0xFF<<8)

#define VIFn_CYCLE_CL_O	(0)
#define VIFn_CYCLE_WL_O	(8)
// VIFn_CYCLE instances
#define VIF0_CYCLE 	((volatile u_int *)(0x10003840))
#define VIF1_CYCLE 	((volatile u_int *)(0x10003c40))



//VIFn_MASK
typedef struct {
	 u_int M0 :2;	// vu mem write masking/filling pattern
	 u_int M1 :2;	// vu mem write masking/filling pattern
	 u_int M2 :2;	// vu mem write masking/filling pattern
	 u_int M3 :2;	// vu mem write masking/filling pattern
	 u_int M4 :2;	// vu mem write masking/filling pattern
	 u_int M5 :2;	// vu mem write masking/filling pattern
	 u_int M6 :2;	// vu mem write masking/filling pattern
	 u_int M7 :2;	// vu mem write masking/filling pattern
	 u_int M8 :2;	// vu mem write masking/filling pattern
	 u_int M9 :2;	// vu mem write masking/filling pattern
	 u_int M10:2;	// vu mem write masking/filling pattern
	 u_int M11:2;	// vu mem write masking/filling pattern
	 u_int M12:2;	// vu mem write masking/filling pattern
	 u_int M13:2;	// vu mem write masking/filling pattern
	 u_int M14:2;	// vu mem write masking/filling pattern
	 u_int M15:2;	// vu mem write masking/filling pattern
} stVIFn_MASK;
// VIFn_MASK SET macro
#define LIB_SET_VIF0_MASK	LIB_SET_VIFn_MASK
#define LIB_SET_VIF1_MASK	LIB_SET_VIFn_MASK
#define LIB_SET_VIFn_MASK(M0, M1, M2, M3, M4, M5, M6, M7, M8, M9, M10, M11, M12, M13, M14, M15) \
	(((u_long)(M0) << 0)     | ((u_long)(M1) << 2)     |\
	 ((u_long)(M2) << 4)     | ((u_long)(M3) << 6)     |\
	 ((u_long)(M4) << 8)     | ((u_long)(M5) << 10)    |\
	 ((u_long)(M6) << 12)    | ((u_long)(M7) << 14)    |\
	 ((u_long)(M8) << 16)    | ((u_long)(M9) << 18)    |\
	 ((u_long)(M10) << 20)   | ((u_long)(M11) << 22)   |\
	 ((u_long)(M12) << 24)   | ((u_long)(M13) << 26)   |\
	 ((u_long)(M14) << 28)   | ((u_long)(M15) << 30))
#define VIFn_MASK_M0_M	(0x3<<0)
#define VIFn_MASK_M1_M	(0x3<<2)
#define VIFn_MASK_M2_M	(0x3<<4)
#define VIFn_MASK_M3_M	(0x3<<6)
#define VIFn_MASK_M4_M	(0x3<<8)
#define VIFn_MASK_M5_M	(0x3<<10)
#define VIFn_MASK_M6_M	(0x3<<12)
#define VIFn_MASK_M7_M	(0x3<<14)
#define VIFn_MASK_M8_M	(0x3<<16)
#define VIFn_MASK_M9_M	(0x3<<18)
#define VIFn_MASK_M10_M	(0x3<<20)
#define VIFn_MASK_M11_M	(0x3<<22)
#define VIFn_MASK_M12_M	(0x3<<24)
#define VIFn_MASK_M13_M	(0x3<<26)
#define VIFn_MASK_M14_M	(0x3<<28)
#define VIFn_MASK_M15_M	(0x3<<30)

#define VIFn_MASK_M0_O	(0)
#define VIFn_MASK_M1_O	(2)
#define VIFn_MASK_M2_O	(4)
#define VIFn_MASK_M3_O	(6)
#define VIFn_MASK_M4_O	(8)
#define VIFn_MASK_M5_O	(10)
#define VIFn_MASK_M6_O	(12)
#define VIFn_MASK_M7_O	(14)
#define VIFn_MASK_M8_O	(16)
#define VIFn_MASK_M9_O	(18)
#define VIFn_MASK_M10_O	(20)
#define VIFn_MASK_M11_O	(22)
#define VIFn_MASK_M12_O	(24)
#define VIFn_MASK_M13_O	(26)
#define VIFn_MASK_M14_O	(28)
#define VIFn_MASK_M15_O	(30)
// VIFn_MASK instances
#define VIF0_MASK 	((volatile u_int *)(0x10003870))
#define VIF1_MASK 	((volatile u_int *)(0x10003c70))



//VIFn_MODE
typedef struct {
	 u_int MOD :2;	// addition mode
	 u_int pad0:30;	// padding
} stVIFn_MODE;
// VIFn_MODE SET macro
#define LIB_SET_VIF0_MODE	LIB_SET_VIFn_MODE
#define LIB_SET_VIF1_MODE	LIB_SET_VIFn_MODE
#define LIB_SET_VIFn_MODE(MOD) \
	(((u_long)(MOD) << 0))
#define VIFn_MODE_MOD_M	(0x3<<0)

#define VIFn_MODE_MOD_O	(0)
// VIFn_MODE instances
#define VIF0_MODE 	((volatile u_int *)(0x10003850))
#define VIF1_MODE 	((volatile u_int *)(0x10003c50))



//VIFn_ITOP
typedef struct {
	 u_int ITOP:10;	// itop value
	 u_int pad0:22;	// padding
} stVIFn_ITOP;
// VIFn_ITOP SET macro
#define LIB_SET_VIF0_ITOP	LIB_SET_VIFn_ITOP
#define LIB_SET_VIF1_ITOP	LIB_SET_VIFn_ITOP
#define LIB_SET_VIFn_ITOP(ITOP) \
	(((u_long)(ITOP) << 0))
#define VIFn_ITOP_ITOP_M	(0x3FF<<0)

#define VIFn_ITOP_ITOP_O	(0)
// VIFn_ITOP instances
#define VIF0_ITOP 	((volatile u_int *)(0x100038d0))
#define VIF1_ITOP 	((volatile u_int *)(0x10003cd0))



//VIFn_ITOPS
typedef struct {
	 u_int ITOPS:10;	// itops value
	 u_int pad0 :22;	// padding
} stVIFn_ITOPS;
// VIFn_ITOPS SET macro
#define LIB_SET_VIF0_ITOPS	LIB_SET_VIFn_ITOPS
#define LIB_SET_VIF1_ITOPS	LIB_SET_VIFn_ITOPS
#define LIB_SET_VIFn_ITOPS(ITOPS) \
	(((u_long)(ITOPS) << 0))
#define VIFn_ITOPS_ITOPS_M	(0x3FF<<0)

#define VIFn_ITOPS_ITOPS_O	(0)
// VIFn_ITOPS instances
#define VIF0_ITOPS 	((volatile u_int *)(0x10003890))
#define VIF1_ITOPS 	((volatile u_int *)(0x10003c90))



//VIF1_BASE
typedef struct {
	 u_int BASE:10;	// data buffer base address
	 u_int pad0:22;	// padding
} stVIF1_BASE;
// VIF1_BASE SET macro
#define LIB_SET_VIF1_BASE(BASE) \
	(((u_long)(BASE) << 0))
#define VIF1_BASE_BASE_M	(0x3FF<<0)

#define VIF1_BASE_BASE_O	(0)
// VIF1_BASE instances
#define VIF1_BASE 	((volatile u_int *)(0x10003ca0))



//VIF1_OFST
typedef struct {
	 u_int OFFSET:10;	// data buffer offset
	 u_int pad0  :22;	// padding
} stVIF1_OFST;
// VIF1_OFST SET macro
#define LIB_SET_VIF1_OFST(OFFSET) \
	(((u_long)(OFFSET) << 0))
#define VIF1_OFST_OFFSET_M	(0x3FF<<0)

#define VIF1_OFST_OFFSET_O	(0)
// VIF1_OFST instances
#define VIF1_OFST 	((volatile u_int *)(0x10003cb0))



//VIF1_TOP
typedef struct {
	 u_int TOP :10;	// data buffer address
	 u_int pad0:22;	// padding
} stVIF1_TOP;
// VIF1_TOP SET macro
#define LIB_SET_VIF1_TOP(TOP) \
	(((u_long)(TOP) << 0))
#define VIF1_TOP_TOP_M	(0x3FF<<0)

#define VIF1_TOP_TOP_O	(0)
// VIF1_TOP instances
#define VIF1_TOP 	((volatile u_int *)(0x10003ce0))



//VIF1_TOPS
typedef struct {
	 u_int TOPS:10;	// data decompression buffer address
	 u_int pad0:22;	// padding
} stVIF1_TOPS;
// VIF1_TOPS SET macro
#define LIB_SET_VIF1_TOPS(TOPS) \
	(((u_long)(TOPS) << 0))
#define VIF1_TOPS_TOPS_M	(0x3FF<<0)

#define VIF1_TOPS_TOPS_O	(0)
// VIF1_TOPS instances
#define VIF1_TOPS 	((volatile u_int *)(0x10003cc0))



//VIFn_MARK
typedef struct {
	 u_int MARK:16;	// mark value set most recently
	 u_int pad0:16;	// padding
} stVIFn_MARK;
// VIFn_MARK SET macro
#define LIB_SET_VIF0_MARK	LIB_SET_VIFn_MARK
#define LIB_SET_VIF1_MARK	LIB_SET_VIFn_MARK
#define LIB_SET_VIFn_MARK(MARK) \
	(((u_long)(MARK) << 0))
#define VIFn_MARK_MARK_M	(0xFFFF<<0)

#define VIFn_MARK_MARK_O	(0)
// VIFn_MARK instances
#define VIF0_MARK 	((volatile u_int *)(0x10003830))
#define VIF1_MARK 	((volatile u_int *)(0x10003c30))



//VIFn_NUM
typedef struct {
	 u_int NUM :8;	// amount of untransferred data
	 u_int pad0:24;	// padding
} stVIFn_NUM;
// VIFn_NUM SET macro
#define LIB_SET_VIF0_NUM	LIB_SET_VIFn_NUM
#define LIB_SET_VIF1_NUM	LIB_SET_VIFn_NUM
#define LIB_SET_VIFn_NUM(NUM) \
	(((u_long)(NUM) << 0))
#define VIFn_NUM_NUM_M	(0xFF<<0)

#define VIFn_NUM_NUM_O	(0)
// VIFn_NUM instances
#define VIF0_NUM 	((volatile u_int *)(0x10003860))
#define VIF1_NUM 	((volatile u_int *)(0x10003c60))



//VIFn_CODE
typedef struct {
	 u_int INMEDIATE:16;	// vifcode inmediate processed most recently
	 u_int NUM      :8;	// vifcode num processed most recently
	 u_int CMD      :8;	// vifcode cmd processed most recently
} stVIFn_CODE;
// VIFn_CODE SET macro
#define LIB_SET_VIF0_CODE	LIB_SET_VIFn_CODE
#define LIB_SET_VIF1_CODE	LIB_SET_VIFn_CODE
#define LIB_SET_VIFn_CODE(INMEDIATE, NUM, CMD) \
	(((u_long)(INMEDIATE) << 0) | ((u_long)(NUM) << 16)      |\
	 ((u_long)(CMD) << 24))
#define VIFn_CODE_INMEDIATE_M	(0xFFFF<<0)
#define VIFn_CODE_NUM_M	(0xFF<<16)
#define VIFn_CODE_CMD_M	(0xFF<<24)

#define VIFn_CODE_INMEDIATE_O	(0)
#define VIFn_CODE_NUM_O	(16)
#define VIFn_CODE_CMD_O	(24)
// VIFn_CODE instances
#define VIF0_CODE 	((volatile u_int *)(0x10003880))
#define VIF1_CODE 	((volatile u_int *)(0x10003c80))



//VIF0_STAT
typedef struct {
	 u_int VPS :2;	// vif0 status
	 u_int VEW :1;	// vif0 e-bit wait
	 u_int pad0:3;	// padding
	 u_int MRK :1;	// vif0 mark detect
	 u_int pad1:1;	// padding
	 u_int VSS :1;	// stop by stop
	 u_int VFS :1;	// stop by forcebreak
	 u_int VIS :1;	// stop by the i bit
	 u_int INT :1;	// interrupt bit detected flag
	 u_int ER0 :1;	// dmatag mismatch error
	 u_int ER1 :1;	// vifcode error
	 u_int pad2:10;	// padding
	 u_int FQC :4;	// amount of efective data in the vif0-fifo
	 u_int pad3:4;	// padding
} stVIF0_STAT;
// VIF0_STAT SET macro
#define LIB_SET_VIF0_STAT(VPS, VEW, MRK, VSS, VFS, VIS, INT, ER0, ER1, FQC) \
	(((u_long)(VPS) << 0)    | ((u_long)(VEW) << 2)    |\
	 ((u_long)(MRK) << 6)    | ((u_long)(VSS) << 8)    |\
	 ((u_long)(VFS) << 9)    | ((u_long)(VIS) << 10)   |\
	 ((u_long)(INT) << 11)   | ((u_long)(ER0) << 12)   |\
	 ((u_long)(ER1) << 13)   | ((u_long)(FQC) << 24))
#define VIF0_STAT_VPS_M	(0x3<<0)
#define VIF0_STAT_VEW_M	(0x1<<2)
#define VIF0_STAT_MRK_M	(0x1<<6)
#define VIF0_STAT_VSS_M	(0x1<<8)
#define VIF0_STAT_VFS_M	(0x1<<9)
#define VIF0_STAT_VIS_M	(0x1<<10)
#define VIF0_STAT_INT_M	(0x1<<11)
#define VIF0_STAT_ER0_M	(0x1<<12)
#define VIF0_STAT_ER1_M	(0x1<<13)
#define VIF0_STAT_FQC_M	(0xF<<24)

#define VIF0_STAT_VPS_O	(0)
#define VIF0_STAT_VEW_O	(2)
#define VIF0_STAT_MRK_O	(6)
#define VIF0_STAT_VSS_O	(8)
#define VIF0_STAT_VFS_O	(9)
#define VIF0_STAT_VIS_O	(10)
#define VIF0_STAT_INT_O	(11)
#define VIF0_STAT_ER0_O	(12)
#define VIF0_STAT_ER1_O	(13)
#define VIF0_STAT_FQC_O	(24)
// VIF0_STAT instances
#define VIF0_STAT 	((volatile u_int *)(0x10003800))



//VIF0_FBRST
typedef struct {
	 u_int RST :1;	// reset
	 u_int FBK :1;	// forcebreak
	 u_int STP :1;	// stop
	 u_int STC :1;	// stall cancel
	 u_int pad0:28;	// padding
} stVIF0_FBRST;
// VIF0_FBRST SET macro
#define LIB_SET_VIF0_FBRST(RST, FBK, STP, STC) \
	(((u_long)(RST) << 0)  | ((u_long)(FBK) << 1)  |\
	 ((u_long)(STP) << 2)  | ((u_long)(STC) << 3))
#define VIF0_FBRST_RST_M	(0x1<<0)
#define VIF0_FBRST_FBK_M	(0x1<<1)
#define VIF0_FBRST_STP_M	(0x1<<2)
#define VIF0_FBRST_STC_M	(0x1<<3)

#define VIF0_FBRST_RST_O	(0)
#define VIF0_FBRST_FBK_O	(1)
#define VIF0_FBRST_STP_O	(2)
#define VIF0_FBRST_STC_O	(3)
// VIF0_FBRST instances
#define VIF0_FBRST 	((volatile u_int *)(0x10003810))



//VIF0_ERR
typedef struct {
	 u_int MII :1;	// mask an interrupt by the i bit of vifcode
	 u_int ME0 :1;	// dmatag mismatch error mask
	 u_int ME1 :1;	// vifcode error mask
	 u_int pad0:29;	// padding
} stVIF0_ERR;
// VIF0_ERR SET macro
#define LIB_SET_VIF0_ERR(MII, ME0, ME1) \
	(((u_long)(MII) << 0)  | ((u_long)(ME0) << 1)  |\
	 ((u_long)(ME1) << 2))
#define VIF0_ERR_MII_M	(0x1<<0)
#define VIF0_ERR_ME0_M	(0x1<<1)
#define VIF0_ERR_ME1_M	(0x1<<2)

#define VIF0_ERR_MII_O	(0)
#define VIF0_ERR_ME0_O	(1)
#define VIF0_ERR_ME1_O	(2)
// VIF0_ERR instances
#define VIF0_ERR 	((volatile u_int *)(0x10003820))



//VIF1_STAT
typedef struct {
	 u_int VPS :2;	// vif1 status
	 u_int VEW :1;	// vif1 e-bit wait
	 u_int VGW :1;	// status waiting for end of gif transfer
	 u_int pad0:2;	// padding
	 u_int MRK :1;	// vif1 mark detect
	 u_int DBF :1;	// double buffer flag
	 u_int VSS :1;	// stop by stop
	 u_int VFS :1;	// stop by forcebreak
	 u_int VIS :1;	// vif1 interrupt stall
	 u_int INT :1;	// interrupt by the i bit
	 u_int ER0 :1;	// dmatag mismatch error
	 u_int ER1 :1;	// vifcode error
	 u_int pad1:9;	// padding
	 u_int FDR :1;	// vif1-fifo transfer direction
	 u_int FQC :5;	// amount of effective data in vif1-fifo
	 u_int pad2:3;	// padding
} stVIF1_STAT;
// VIF1_STAT SET macro
#define LIB_SET_VIF1_STAT(VPS, VEW, VGW, MRK, DBF, VSS, VFS, VIS, INT, ER0, ER1, FDR, FQC) \
	(((u_long)(VPS) << 0)    | ((u_long)(VEW) << 2)    |\
	 ((u_long)(VGW) << 3)    | ((u_long)(MRK) << 6)    |\
	 ((u_long)(DBF) << 7)    | ((u_long)(VSS) << 8)    |\
	 ((u_long)(VFS) << 9)    | ((u_long)(VIS) << 10)   |\
	 ((u_long)(INT) << 11)   | ((u_long)(ER0) << 12)   |\
	 ((u_long)(ER1) << 13)   | ((u_long)(FDR) << 23)   |\
	 ((u_long)(FQC) << 24))
#define VIF1_STAT_VPS_M	(0x3<<0)
#define VIF1_STAT_VEW_M	(0x1<<2)
#define VIF1_STAT_VGW_M	(0x1<<3)
#define VIF1_STAT_MRK_M	(0x1<<6)
#define VIF1_STAT_DBF_M	(0x1<<7)
#define VIF1_STAT_VSS_M	(0x1<<8)
#define VIF1_STAT_VFS_M	(0x1<<9)
#define VIF1_STAT_VIS_M	(0x1<<10)
#define VIF1_STAT_INT_M	(0x1<<11)
#define VIF1_STAT_ER0_M	(0x1<<12)
#define VIF1_STAT_ER1_M	(0x1<<13)
#define VIF1_STAT_FDR_M	(0x1<<23)
#define VIF1_STAT_FQC_M	(0x1F<<24)

#define VIF1_STAT_VPS_O	(0)
#define VIF1_STAT_VEW_O	(2)
#define VIF1_STAT_VGW_O	(3)
#define VIF1_STAT_MRK_O	(6)
#define VIF1_STAT_DBF_O	(7)
#define VIF1_STAT_VSS_O	(8)
#define VIF1_STAT_VFS_O	(9)
#define VIF1_STAT_VIS_O	(10)
#define VIF1_STAT_INT_O	(11)
#define VIF1_STAT_ER0_O	(12)
#define VIF1_STAT_ER1_O	(13)
#define VIF1_STAT_FDR_O	(23)
#define VIF1_STAT_FQC_O	(24)
// VIF1_STAT instances
#define VIF1_STAT 	((volatile u_int *)(0x10003c00))



//VIF1_FBRST
typedef struct {
	 u_int RST :1;	// reset
	 u_int FBK :1;	// forcebreak
	 u_int STP :1;	// stop
	 u_int STC :1;	// stall cancel
	 u_int pad0:28;	// padding
} stVIF1_FBRST;
// VIF1_FBRST SET macro
#define LIB_SET_VIF1_FBRST(RST, FBK, STP, STC) \
	(((u_long)(RST) << 0)  | ((u_long)(FBK) << 1)  |\
	 ((u_long)(STP) << 2)  | ((u_long)(STC) << 3))
#define VIF1_FBRST_RST_M	(0x1<<0)
#define VIF1_FBRST_FBK_M	(0x1<<1)
#define VIF1_FBRST_STP_M	(0x1<<2)
#define VIF1_FBRST_STC_M	(0x1<<3)

#define VIF1_FBRST_RST_O	(0)
#define VIF1_FBRST_FBK_O	(1)
#define VIF1_FBRST_STP_O	(2)
#define VIF1_FBRST_STC_O	(3)
// VIF1_FBRST instances
#define VIF1_FBRST 	((volatile u_int *)(0x10003c10))



//VIF1_ERR
typedef struct {
	 u_int MII :1;	// mask an interrupt by the i bit of vifcode
	 u_int ME0 :1;	// dmatag mismatch error mask
	 u_int ME1 :1;	// vifcode error mask
	 u_int pad0:29;	// padding
} stVIF1_ERR;
// VIF1_ERR SET macro
#define LIB_SET_VIF1_ERR(MII, ME0, ME1) \
	(((u_long)(MII) << 0)  | ((u_long)(ME0) << 1)  |\
	 ((u_long)(ME1) << 2))
#define VIF1_ERR_MII_M	(0x1<<0)
#define VIF1_ERR_ME0_M	(0x1<<1)
#define VIF1_ERR_ME1_M	(0x1<<2)

#define VIF1_ERR_MII_O	(0)
#define VIF1_ERR_ME0_O	(1)
#define VIF1_ERR_ME1_O	(2)
// VIF1_ERR instances
#define VIF1_ERR 	((volatile u_int *)(0x10003c20))


#endif
//
