/***************************************************************
/  Ifcaro3D - Preview                                          /
/                                                              /
/  Creado por Ifcaro <taslokooo@gmail.com>                     /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Contiene codigo de ps2game:                                 /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include "math.h"

//Tipos
#define TEntity Tentity*
#define TCamera ObjectCamera*

//Entities

#define TENTITY_CAMARA 1
#define TENTITY_OBJETO 2
#define TENTITY_LUZ 3

typedef struct
    {
    int clase;
	ObjectCamera *escamara;
	ObjectLight *esluz;
	Object3D *esobjeto;
	ODE_object ode;
	int id;
	int solid;
	long posicion[3]; 
	long rotacion[3]; 
    } Tentity;

void RenderWorld();
	
TEntity CreateCamera();
TEntity CreateLight();
TEntity LoadMesh(char* archivo, ...);
void FreeEntity(TEntity entity);

void SetEntityMass(TEntity entity, int mass);
void PositionEntity(TEntity entity, float x, float y, float z);
void MoveEntity(TEntity entity, float x, float y, float z);
void RotateEntity(TEntity entity, float x, float y, float z);
void TurnEntity(TEntity entity, float x, float y, float z);
void EntityColor(TEntity entity, unsigned char r, unsigned char g, unsigned char b);
void EntityAlpha(TEntity entity, float alpha);

int EntityX(TEntity entity);
int EntityY(TEntity entity);
int EntityZ(TEntity entity);
int EntityPitch(TEntity entity);
int EntityYaw(TEntity entity);
int EntityRoll(TEntity entity);

