/***************************************************************
/  la lib 0.1 (snapshot 2)                                     /
/  Copyright (C) 2003 - Victor Muoz                           /
/                                                              /
/  header:   libDma (libDma.h)                                 /
/  author:   djhuevo (Victor Muoz)                            /
/  last mod: 10-10-2003                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#ifndef _LIBDMA_H_
#define _LIBDMA_H_

#include <libPs2.h>
#include <libKernel.h>
#include <_dmac.h>

// structs
typedef struct {
    u_char  sts;
    u_char	std;
    u_char	mfd;
    u_char	rcycle;
    u_short	express;
    u_short	notify;
    u_short	sqwc;
    u_short	tqwc;
    void	*rbadr;
    u_int	rbmsk;
} libDmaEnv;

typedef struct _libDmaTag {
    u_short           qwc;
    u_char            mark;
    u_char            id;
    struct _libDmaTag *next;
    u_int  pad0[2];
} libDmaTag __attribute__ ((aligned(16)));

typedef struct {
    stDn_CHCR      chcr;
    u_int          pad0[3];
    void           *madr;
    u_int          pad1[3];
    u_int          qwc;
    u_int          pad2[3];
    libDmaTag      *tadr;
    u_int          pad3[3];
    void           *as0;
    u_int          pad4[3];
    void           *as1;
    u_int          pad5[3];
    u_int          pad6[4];
    u_int          pad7[4];
    void           *sadr;
    u_int          pad8[3];
} volatile libDmaChan;

////



#define setADR(v,x)	{if ((v)!=(void *)-1) (v)=(libDmaTag *)(x);}

#define DMA_CHANS 10

#define LIB_DMA_VIF0      0
#define LIB_DMA_VIF1      1
#define LIB_DMA_GIF       2
#define LIB_DMA_fromIPU   3
#define LIB_DMA_toIPU     4
#define LIB_DMA_SIF0      5
#define LIB_DMA_SIF1      6
#define LIB_DMA_SIF2      7
#define LIB_DMA_fromSPR   8
#define LIB_DMA_toSPR     9

// prototipos
void memclr(char* buffer,int count);
libDmaChan* libDmaGetChan(int id);
libDmaEnv* libDmaGetEnv(libDmaEnv *denv);
int libDmaPause(libDmaChan *d);
int libDmaPutEnv(libDmaEnv* env);
void *libDmaPutStallAddr(void *addr);
int libDmaReset(int mode);
int libDmaRestart(libDmaChan *d);
void libDmaSend(libDmaChan *d, void *tag);
void libDmaSendI(libDmaChan *d,void* addr,int size);
void libDmaSendN(libDmaChan *d,void* addr,int size);
int libDmaSync(libDmaChan *d, int mode,int timeout);

#endif
