/***************************************************************
/  la lib 0.1 (snapshot 2)                                     /
/  Copyright (C) 2003 - Victor Muoz                           /
/                                                              /
/  header:   libGs (libGs.h)                                   /
/  author:   djhuevo (Victor Muoz)                            /
/  last mod: 10-10-2003                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#ifndef _LIBGS_H_
#define _LIBGS_H_

#include <libPs2.h>
#include <_gs.h>
#include <_dmac.h>

// misc macros
#define LIB_GIF_SET_TAG(NLOOP, EOP, PRE, PRIM, FLG, NREG) \
	(((u_long)(NLOOP) << 0)      | ((u_long)(EOP) << 15)       |\
	 ((u_long)(PRE) << 46)       | ((u_long)(PRIM) << 47)      |\
	 ((u_long)(FLG) << 58)       | ((u_long)(NREG) << 60))


// misc graphics values
#define LIB_CRT_VESA                0
#define LIB_CRT_NTSC                2
#define LIB_CRT_PAL                 3
#define LIB_CRT_AUTO                (((*((char*)0x1FC7FF52))=='E')+2)
#define LIB_CRT_NOINTERLACE         0
#define LIB_CRT_INTERLACE           1
#define	LIB_CRT_FIELD               0
#define	LIB_CRT_FRAME               1
#define LIB_DB_NOCLEAR              0
#define LIB_DB_CLEAR                1

#define LIB_PRIM_POINT     0
#define LIB_PRIM_LINE      1
#define LIB_PRIM_LINESTRIP 2
#define LIB_PRIM_TRIANGLE  3
#define LIB_PRIM_TSTRIP    4
#define LIB_PRIM_TFAN      5
#define LIB_PRIM_SPRITE    6

#define LIB_GS_PSMCT32     0
#define LIB_GS_PSMCT24     1
#define LIB_GS_PSMCT16     2
#define LIB_GS_PSMCT16S    10
#define LIB_GS_PSMT8       19
#define LIB_GS_PSMT4       20
#define LIB_GS_PSMT8H      27
#define LIB_GS_PSMT4HL     36
#define LIB_GS_PSMT4HH     44
#define LIB_GS_PSMZ32      48
#define LIB_GS_PSMZ24      49
#define LIB_GS_PSMZ16      50
#define LIB_GS_PSMZ16S     58

#define LIB_TEST_ZNONE     0
#define LIB_TEST_ZALWAYS   1
#define LIB_TEST_ZGEQUAL   2
#define LIB_TEST_ZGREATER  3

#define LIB_TFX_MODULATE   0
#define LIB_TFX_DECAL      1
#define LIB_TFX_HILIGHT    2
#define LIB_TFX_GHLIGHT2   3

#define LIB_FLT_NEAREST                0
#define LIB_FLT_LINEAR                 1
#define LIB_FLT_NEAREST_MIPMAP_NEAREST 2
#define LIB_FLT_NEAREST_MIPMAP_LENEAR  3
#define LIB_FLT_LINEAR_MIPMAP_NEAREST  4
#define LIB_FLT_LINEAR_MIPMAP_LINEAR   5

// GS registers
#define LIB_GSREG_PRIM       0x00
#define LIB_GSREG_RGBAQ      0x01
#define LIB_GSREG_ST         0x02
#define LIB_GSREG_UV         0x03
#define LIB_GSREG_XYZF2      0x04
#define LIB_GSREG_XYZ2       0x05
#define LIB_GSREG_TEX0_1     0x06
#define LIB_GSREG_TEX0_2     0x07
#define LIB_GSREG_CLAMP_1    0x08
#define LIB_GSREG_CLAMP_2    0x09
#define LIB_GSREG_FOG        0x0A
#define LIB_GSREG_XYZF3      0x0C
#define LIB_GSREG_XYZ3       0x0D
#define LIB_GSREG_RGBAQ2     0x11
#define LIB_GSREG_ST2        0x12
#define LIB_GSREG_UV2        0x13
#define LIB_GSREG_TEX1_1     0x14
#define LIB_GSREG_TEX1_2     0x15
#define LIB_GSREG_TEX2_1     0x16
#define LIB_GSREG_TEX2_2     0x17
#define LIB_GSREG_XYOFFSET_1 0x18
#define LIB_GSREG_XYOFFSET_2 0x19
#define LIB_GSREG_PRMODECONT 0x1A
#define LIB_GSREG_PRMODE     0x1B
#define LIB_GSREG_TEXCLUT    0x1C
#define LIB_GSREG_SCANMSK    0x22
#define LIB_GSREG_MIPTBP1_1  0x34
#define LIB_GSREG_MIPTBP1_2  0x35
#define LIB_GSREG_MIPTBP2_1  0x36
#define LIB_GSREG_MIPTBP2_2  0x37
#define LIB_GSREG_TEXA       0x3B
#define LIB_GSREG_FOGCOL     0x3D
#define LIB_GSREG_TEXFLUSH   0x3F
#define LIB_GSREG_SCISSOR_1  0x40
#define LIB_GSREG_SCISSOR_2  0x41
#define LIB_GSREG_ALPHA_1    0x42
#define LIB_GSREG_ALPHA_2    0x43
#define LIB_GSREG_DIMX       0x44
#define LIB_GSREG_DTHE       0x45
#define LIB_GSREG_COLCLAMP   0x46
#define LIB_GSREG_TEST_1     0x47
#define LIB_GSREG_TEST_2     0x48
#define LIB_GSREG_PABE       0x49
#define LIB_GSREG_FBA_1      0x4A
#define LIB_GSREG_FBA_2      0x4B
#define LIB_GSREG_FRAME_1    0x4C
#define LIB_GSREG_FRAME_2    0x4D
#define LIB_GSREG_ZBUF_1     0x4E
#define LIB_GSREG_ZBUF_2     0x4F
#define LIB_GSREG_BITBLTBUF  0x50
#define LIB_GSREG_TRXPOS     0x51
#define LIB_GSREG_TRXREG     0x52
#define LIB_GSREG_TRXDIR     0x53
#define LIB_GSREG_HWREG      0x54
#define LIB_GSREG_SIGNAL     0x60
#define LIB_GSREG_FINISH     0x61
#define LIB_GSREG_LABEL      0x62
#define LIB_GSREG_NOP        0x7F

typedef struct {
    u_long NLOOP:15;
    u_long EOP:1;
    u_long pad16:16;
    u_long id:14;
    u_long PRE:1;
    u_long PRIM:11;
    u_long FLG:2;
    u_long NREG:4;
    u_long REGS0:4;
    u_long REGS1:4;
    u_long REGS2:4;
    u_long REGS3:4;
    u_long REGS4:4;
    u_long REGS5:4;
    u_long REGS6:4;
    u_long REGS7:4;
    u_long REGS8:4;
    u_long REGS9:4;
    u_long REGSA:4;
    u_long REGSB:4;
    u_long REGSC:4;
    u_long REGSD:4;
    u_long REGSE:4;
    u_long REGSF:4;
} libGifTag;

typedef struct {
    stALPHA_x  alpha1;
    u_long     alpha1r;
    stPABE     pabe;
    u_long     paber;
    stTEXA     texa;
    u_long     texar;
    stFBA_x    fba1;
    u_long     fba1r;
} libGsAlphaEnv;

typedef struct {
    stTEST_x  testa;
    u_long  testar;
    stPRIM  prim;
    u_long  primr;
    stRGBAQ rgbaq;
    u_long  rgbaqr;
    stXYZx  xyz2a;
    u_long  xyz2ar;
    stXYZx  xyz2b;
    u_long  xyz2br;
    stTEST_x  testb;
    u_long  testbr;
} libGsClear;

typedef struct {
	stPMODE       pmode;
	stSMODE2      smode2;
	stDISPFBn     dispfb;
	stDISPLAYn    display;
	stBGCOLOR     bgcolor;
} libGsDispEnv;

typedef struct {
    stFRAME_x      frame1;
    u_long         frame1r;
    stZBUF_x       zbuf1;
    u_long         zbuf1r;
    stXYOFFSET_x   xyoffset1;
    u_long         xyoffset1r;
    stSCISSOR_x    scissor1;
    u_long         scissor1r;
    stPRMODECONT   prmodecont;
    u_long         prmodecontr;
    stCOLCLAMP     colclamp;
    u_long         colclampr;
    stDTHE         dthe;
    u_long         dther;
    stTEST_x       test1;
    u_long         test1r;
} libGsDrawEnv1;

typedef struct {
    libGsDispEnv   dispenv[2];
    libGifTag      giftag0;
    libGsDrawEnv1  drawenv0;
    libGsClear     clear0;
    libGifTag      giftag1;
    libGsDrawEnv1  drawenv1;
    libGsClear     clear1;
} libGsDBuff;

typedef struct {
	libGifTag	giftag0;
	stBITBLTBUF	bitbltbuf;
	u_long		bitbltbufr;
	stTRXPOS	trxpos;
	u_long		trxposr;
	stTRXREG	trxreg;
	u_long		trxregr;
	stTRXDIR	trxdir;
	u_long		trxdirr;
	libGifTag	giftag1;
} libGsLoadImage;

typedef struct {
	u_int		vifcode[4];
	libGifTag	giftag;
	stBITBLTBUF	bitbltbuf;
	u_long		bitbltbufr;
	stTRXPOS	trxpos;
	u_long		trxposr;
	stTRXREG	trxreg;
	u_long		trxregr;
	stFINISH	finish;
	u_long		finishr;
	stTRXDIR	trxdir;
	u_long		trxdirr;
} libGsStoreImage;

typedef struct {
    stTEXFLUSH texflush;
    u_long     texflushr;
    stTEX0_x   tex01;
    u_long     tex01r;
    stTEX1_x   tex11;
    u_long     tex11r;
    stCLAMP_x  clamp1;
    u_long     clamp1r;
} libGsTexEnv;


// prototypes
int libGsExecLoadImage(libGsLoadImage *loadImage, u_long128 *ptr);
int libGsExecStoreImage(libGsStoreImage *storeImage, u_long128 *ptr);
void libGsPutDispEnv(libGsDispEnv *dispEnv);
int libGsPutDrawEnv(libGifTag *gifTag);
u_long libGsPutIMR(u_long newIMR);
void libGsResetGraph(short mode, short interMode, short outMode, short FFMode);
void libGsResetPath();
int libGsSetDefAlphaEnv(libGsAlphaEnv *alphaEnv, short pabe);
int libGsSetDefClear(libGsClear *clear, short ztest, short x, short y, short w, short h, u_char r, u_char g, u_char b, u_char a, u_int z);
void libGsSetDefDBuff(libGsDBuff *DBuff, short psm, short w, short h, short ztest, short zpsm,  short clear);
void libGsSetDefDispEnv(libGsDispEnv *dispEnv, short psm, short w, short h, short dx, short dy);
int libGsSetDefDrawEnv(libGsDrawEnv1 *drawEnv, short psm, short w, short h, short ztest, short zpsm);
int libGsSetDefLoadImage(libGsLoadImage *loadImage, short dbp, short dbw, short dpsm, short x, short y, short w, short h);
int libGsSetDefStoreImage(libGsStoreImage *storeImage, short sbp, short sbw, short spsm, short x, short y, short w, short h);
int libGsSetDefTexEnv(libGsTexEnv *texEnv, short flush, short tbp0, short tbw, short psm, short tw, short th, short tfx, short cbp, short cpsm, short cld, short filter);
void libGsSetHalfOffset(libGsDrawEnv1 *drawEnv, short cx, short cy, short off);
int libGsSwapDBuff(libGsDBuff *DBuff, int current);
int libGsSyncPath(int mode, short p1);
int libGsSyncV();
short libGszbufaddr(short psm, short w, short h);
void VSync();
u_long VSync2();

#endif
