/***************************************************************
/  Ifcaro3D - Preview                                          /
/                                                              /
/  Creado por Ifcaro <taslokooo@gmail.com>                     /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Contiene codigo de ps2game:                                 /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include "Ifcaro3D.h"
#include "entities.h"

// LISTAS (interno)

void asignarluz(PtrNodoLuz aux, Object3D *objeto){
   if ( aux != NULL ) {
      while ( aux != NULL ) { 
		if(aux->id > 0){
			//printf("ASIGNANDO LUZ %d A OBJETO %d\n",aux->info,objeto);
			objectSetLight(objeto,aux->id-1, aux->info);
			//printf("ASIGNADA\n");
		}
         aux = aux->sig;   
      } 
   } 
}

void asignarluz2(PtrNodoLuz luces, PtrNodoObj objetos ){ 
   if ( luces != NULL ) {
	  while ( luces != NULL ) { 
		if(luces->id > 0){
		   if ( objetos != NULL ) {
		      while ( objetos != NULL ) { 
				if(objetos->info != NULL){
					//printf("ASIGNANDO LUZ %d A OBJETO %d\n",luces->info,objetos->info);
					objectSetLight(objetos->info,luces->id-1, luces->info);
					//printf("ASIGNADA\n");
				}
		         objetos = objetos->sig;   
		      } 
		   } 
		}
		 luces = luces->sig;   
	  } 
   } 
} 

void renderList( PtrNodoObj aux ){ 
	float x,y,z;

	if ( aux != NULL ) {
      while ( aux != NULL ) { 
		if(aux->info != NULL){
		
			if(aux->solid==1 || aux->solid==2){
				x=dBodyGetPosition(aux->ode.body)[0];
				y=dBodyGetPosition(aux->ode.body)[1];
				z=dBodyGetPosition(aux->ode.body)[2];
				objectTranslate(aux->info,x,y,z);
				
				/*libVu0FMatrix *m=(libVu0FMatrix*)dBodyGetRotation(aux->ode.body);
				
				// Assuming the angles are in radians.
				if (m[0][1][0] > 0.998) { // singularity at north pole
					y = atan2f(m[0][0][2],m[0][2][2]);
					z = PI/2;
					x = 0;
					return;
				}
				if (m[0][1][0] < -0.998) { // singularity at south pole
					y = atan2f(m[0][0][2],m[0][2][2]);
					z = PI/2;
					x = 0;
					return;
				}
				y = atan2f(-m[0][2][0],m[0][0][0]);
				x = atan2f(-m[0][1][2],m[0][1][1]);
				z = asinf(m[0][1][0]);		
				
			    while(z > PI) z -= PI_2;

			    // y por debajo
			    while(z < -PI) z += PI_2;*/
				
				dReal *R = (dReal *) dBodyGetRotation(aux->ode.body);
				x  = atan2f(R[9], R[10]);	//phi
				y = asinf(-R[8]);		//theta
				z   = atan2f(R[4], R[0]);	//greek Y
				
				objectRotate(aux->info,-x,-y,-z);
			}
						
			objectRender(aux->info);
			
		}
         aux = aux->sig;   
      } 
   } 
} 

//lista objetos

void insObject( PtrNodoObj *sPtr, Tentity *valor ){
	if (*sPtr==NULL){
		PtrNodoObj nuevo = (PtrNodoObj) malloc( sizeof( NodoListaObj ) ); 
		memset (nuevo,0,sizeof(nuevo));
		if ( nuevo != NULL ) { 
			count++;
			nuevo->info = valor->esobjeto; 
			nuevo->solid=valor->solid;
			nuevo->ode=valor->ode;
			nuevo->id = count;
			valor->id=count;
			nuevo->sig = NULL;
			//printf("ASIGNANDO OBJETO %d CON ODE %d\n",nuevo->info,nuevo->ode);
			*sPtr=nuevo; 
		}else{ 
			printf( "No hay memoria disponible.\n" ); 
		}
	}else{
		insObject( &(*sPtr)->sig, valor);
	}
}

char borrarObject( PtrNodoObj *sPtr, int id ){ 
   PtrNodoObj ant;
   PtrNodoObj aux; 
   PtrNodoObj tempPtr;    

   if ( id == ( *sPtr )->id ) { 
      tempPtr = *sPtr;
      *sPtr = ( *sPtr )->sig;
      free( tempPtr ); 
      return id;
   } else { 
      ant = *sPtr;
      aux = ( *sPtr )->sig;
      while ( aux != NULL && aux->id != id ) { 
         ant = aux;         
         aux = aux->sig; 
      }

      if ( aux != NULL ) { 
         tempPtr = aux;
         ant->sig = aux->sig;
         free( tempPtr );
         return id;
      }
   
}
 return '\0';

} 

int isEmptyObject( PtrNodoObj sPtr ){ 
   return sPtr == NULL;
} 

void borrarpriObject( PtrNodoObj *sPtr ){

PtrNodoObj temp;

   if (*sPtr != NULL)
      {
       temp = *sPtr;
       *sPtr = (*sPtr)->sig;
       free(temp);
      }

}

void liberarlistaObject ( PtrNodoObj *sPtr ){

    while (*sPtr != NULL) 
        borrarpriObject(sPtr);

}

void liberarlistaRObject ( PtrNodoObj *sPtr ){

    if (*sPtr != NULL){ 
		borrarpriObject(sPtr);
          liberarlistaRObject(sPtr); 
	}  

}

//lista luces

void insLuz( PtrNodoLuz *sPtr, Tentity *valor ){
	if (*sPtr==NULL){
		PtrNodoLuz nuevo = (PtrNodoLuz) malloc( sizeof( NodoListaLuz ) ); 
		memset (nuevo,0,sizeof(nuevo));
		if ( nuevo != NULL ) { 
			countluz++;
			nuevo->info = valor->esluz; 
			nuevo->id = countluz;
			valor->id=countluz;
			nuevo->sig = NULL;
			//printf("AGREGADA LUZ: %d\n",countluz);
			*sPtr=nuevo; 
		}else{ 
			printf( "No hay memoria disponible.\n" );
		}
	}else{
		insLuz( &(*sPtr)->sig, valor);
	}
}

char borrarLuz( PtrNodoLuz *sPtr, int id ){ 

   PtrNodoLuz ant;
   PtrNodoLuz aux; 
   PtrNodoLuz tempPtr;    

   if ( id == ( *sPtr )->id ) { 
      tempPtr = *sPtr;
      *sPtr = ( *sPtr )->sig;
      free( tempPtr ); 
      return id;
   } else { 
      ant = *sPtr;
      aux = ( *sPtr )->sig;
      while ( aux != NULL && aux->id != id ) { 
         ant = aux;         
         aux = aux->sig; 
      }

      if ( aux != NULL ) { 
         tempPtr = aux;
         ant->sig = aux->sig;
         free( tempPtr );
         return id;
      }
}
 return '\0';

} 

int isEmptyLuz( PtrNodoLuz sPtr ){ 
   return sPtr == NULL;
} 

void borrarpriLuz( PtrNodoLuz *sPtr ){

PtrNodoLuz temp;

   if (*sPtr != NULL)
      {
       temp = *sPtr;
       *sPtr = (*sPtr)->sig;
       free(temp);
      }

}

void liberarlistaLuz ( PtrNodoLuz *sPtr ){

    while (*sPtr != NULL) 
        borrarpriLuz(sPtr);

}

void liberarlistaRLuz ( PtrNodoLuz *sPtr ){

    if (*sPtr != NULL){ 
		borrarpriLuz(sPtr);
          liberarlistaRLuz(sPtr); 
	}  

}
