/***************************************************************
/  Ifcaro3D - Preview                                          /
/                                                              /
/  Creado por Ifcaro <taslokooo@gmail.com>                     /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Contiene codigo de ps2game:                                 /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include "Ifcaro3D.h"

static char actAlign[6];
static int actuators;

extern u8 *freepad_irx;
extern int size_freepad_irx;

extern u8 *freesio2_irx;
extern int size_freesio2_irx;

int waitPadReady(int port, int slot);
void loadModules(void);
int initializePad(int port, int slot);
int getBitButton(int button);

int PadModulesLoaded=0;

void SysPadLoadModules()
    {
    PadModulesLoaded=1;
    loadModules();
    padInit(0);
    }



padData *SysInitPad(int port,int slot)
    {     
    int ret;

	
	
    padData *data;
    // damos memoria a la estructura
    data = (padData *)malloc(sizeof(padData));
    data->padBuf = (char *)memalign(64,256);
    // -------------------------------------


    if(PadModulesLoaded==0)
    	SysPadLoadModules();


    data->port      = port;
    data->slot      = slot;
    data->connected = 1;
    
    // port = 0; // 0 -> Connector 1, 1 -> Connector 2
    // slot = 0; // Always zero if not using multitap
    printf("PortMax: %d\n", padGetPortMax());
    printf("SlotMax: %d\n", padGetSlotMax(port));
	    
    if((ret = padPortOpen(data->port, data->slot, &data->padBuf[0])) == 0)
        {
        printf("padOpenPort failed: %d\n", ret);
        data->connected = 0;
        return NULL;
        }

    if(!initializePad(data->port, data->slot))
        { 
        printf("pad initalization failed!\n");
        data->connected = 0;
        return NULL;
        }

    return data;
    }

//
// Me interesa capturar aqui si el pad esta disconnected
//
void SysPadGetData(padData *data)
    {
    int ret;

    if (data->connected == 0 )return;

    ret=padGetState(data->port, data->slot);
    while((ret != PAD_STATE_STABLE) && (ret != PAD_STATE_FINDCTP1)) 
        {
            // if(ret==PAD_STATE_DISCONN) 
            // {
            // printf("Pad(%d, %d) is disconnected\n", data->port, data->slot);
            // }
        ret=padGetState(data->port, data->slot);
        }

    ret = padRead(data->port, data->slot, &data->buttons); 
    if (ret != 0) 
        {
        // data->paddata = 0xffff ^ ((data->buttons.btns[0] << 8) | data->buttons.btns[1]);
        data->paddata = 0xffff ^ data->buttons.btns;

        }

    // Todos los botones a off
   	data->LEFT     = 0;
   	data->DOWN     = 0;
   	data->RIGHT    = 0;
   	data->UP       = 0;
   	data->START    = 0;
   	data->R3       = 0;
   	data->L3       = 0;
   	data->SELECT   = 0;
   	data->SQUARE   = 0;
   	data->CROSS    = 0;
   	data->CIRCLE   = 0;
   	data->TRIANGLE = 0;
   	data->R1       = 0;
   	data->L1       = 0;
   	data->R2       = 0;
   	data->L2       = 0;
	data->R3_LEFT  = 0;
	data->R3_RIGHT = 0;
	data->R3_UP	   = 0;
	data->R3_DOWN  = 0;
	data->L3_LEFT  = 0;
	data->L3_RIGHT = 0;
	data->L3_UP	   = 0;
	data->L3_DOWN  = 0;	
	
    if(data->paddata & PAD_LEFT)
        {
        data->tickCount[0]++;
        if(data->tickCount[0] > data->tick[0]) 
            {
            data->LEFT = 1;
            data->tickCount[0] = 0;
            }
        }
    else data->tickCount[0] = data->tick[0];
    
    if(data->paddata & PAD_DOWN)
        {
        data->tickCount[1]++;
        if(data->tickCount[1] > data->tick[1])
            {
            data->DOWN = 1;
            data->tickCount[1] = 0;
            }
        }
    else data->tickCount[1] = data->tick[1];

    if(data->paddata & PAD_RIGHT)
        {
        data->tickCount[2]++;
        if(data->tickCount[2] > data->tick[2]) 
            {
            data->RIGHT = 1;
            data->tickCount[2] = 0;
            }
        }
    else data->tickCount[2] = data->tick[2];

    if(data->paddata & PAD_UP)
        {
        data->tickCount[3]++;
        if(data->tickCount[3] > data->tick[3]) 
            {
            data->UP = 1;
            data->tickCount[3] = 0;
            }
        }
    else data->tickCount[3] = data->tick[3];


    if(data->paddata & PAD_START)
        {
        data->tickCount[4]++;
        if(data->tickCount[4] > data->tick[4])
            {
            data->START = 1;
            data->tickCount[4] = 0;
            }
        }
    else data->tickCount[4] = data->tick[4];


    if(data->paddata & PAD_R3)
        {
        data->tickCount[5]++;
        if(data->tickCount[5] > data->tick[5])
            {
            data->R3 = 1;
            data->tickCount[5] = 0;
            }
        }
    else data->tickCount[5] = data->tick[5];

    if(data->paddata & PAD_L3)
        {
        data->tickCount[6]++;
        if(data->tickCount[6] > data->tick[6])
            {
            data->L3 = 1;
            data->tickCount[6] = 0;
            }
        }
    else data->tickCount[6] = data->tick[6];

    if(data->paddata & PAD_SELECT)
        {
        data->tickCount[7]++;
        if(data->tickCount[7] > data->tick[7])
            {
            data->SELECT = 1;
            data->tickCount[7] = 0;
            }
        }
    else data->tickCount[7] = data->tick[7];

    if(data->paddata & PAD_SQUARE)
        {
        data->tickCount[8]++;
        if(data->tickCount[8] > data->tick[8])
            {
            data->SQUARE = 1;
            data->tickCount[8] = 0;
            }
        }
    else data->tickCount[8] = data->tick[8];

    if(data->paddata & PAD_CROSS)
        {
        data->tickCount[9]++;
        if(data->tickCount[9] > data->tick[9])
            {
            data->CROSS = 1;
            data->tickCount[9] = 0;
            }
        }
    else data->tickCount[9] = data->tick[9];

    if(data->paddata & PAD_CIRCLE)
        {
        data->tickCount[10]++;
        if(data->tickCount[10] > data->tick[10])
            {
            data->CIRCLE = 1;
            data->tickCount[10] = 0;
            }
        }
    else data->tickCount[10] = data->tick[10];

    if(data->paddata & PAD_TRIANGLE)
        {
        data->tickCount[11]++;
        if(data->tickCount[11] > data->tick[11])
            {
            data->TRIANGLE = 1;
            data->tickCount[11] = 0;
            }
        }
    else data->tickCount[11] = data->tick[11];

    if(data->paddata & PAD_R1)
        {
        data->tickCount[12]++;
        if(data->tickCount[12] > data->tick[12])
            {
            data->R1 = 1;
            data->tickCount[12] = 0;
            }
        }
    else data->tickCount[12] = data->tick[12];

    if(data->paddata & PAD_L1)
        {
        data->tickCount[13]++;
        if(data->tickCount[13] > data->tick[13])
            {
            data->L1 = 1;
            data->tickCount[13] = 0;
            }
        }
    else data->tickCount[13] = data->tick[13];

    if(data->paddata & PAD_R2)
        {
        data->tickCount[14]++;
        if(data->tickCount[14] > data->tick[14])
            {
            data->R2 = 1;
            data->tickCount[14] = 0;
            }
        }
    else data->tickCount[14] = data->tick[14];

    if(data->paddata & PAD_L2)
        {
        data->tickCount[15]++;
        if(data->tickCount[15] > data->tick[15])
            {
            data->L2 = 1;
            data->tickCount[15] = 0;
            }
        }
    else data->tickCount[15] = data->tick[15];

	int rjoy_h = data->buttons.rjoy_h - 128;

	if (rjoy_h <-50){
	    data->tickCount[16]++;
        if(data->tickCount[16] > data->tick[16]) 
            {
            data->R3_LEFT=-rjoy_h;
            data->tickCount[16] = 0;
            }
	}else data->tickCount[16] = data->tick[16];
	if(rjoy_h > 50){
	    data->tickCount[17]++;
        if(data->tickCount[17] > data->tick[17]) 
            {
			data->R3_RIGHT=rjoy_h;
            data->tickCount[17] = 0;
            }
	}else data->tickCount[17] = data->tick[17];

	int rjoy_v = data->buttons.rjoy_v - 128;
	if (rjoy_v <-50){
	    data->tickCount[18]++;
        if(data->tickCount[18] > data->tick[18]) 
            {
			data->R3_UP=-rjoy_v;
            data->tickCount[18] = 0;
            }
	}else data->tickCount[18] = data->tick[18];
	if(rjoy_v >50){
	    data->tickCount[19]++;
        if(data->tickCount[19] > data->tick[19]) 
            {
			data->R3_DOWN=rjoy_v;
            data->tickCount[19] = 0;
            }
	}else data->tickCount[19] = data->tick[19];

	int ljoy_h = data->buttons.ljoy_h - 128;
	if (ljoy_h <-50){
	    data->tickCount[20]++;
        if(data->tickCount[20] > data->tick[20]) 
            {
			data->L3_LEFT=-ljoy_h;
            data->tickCount[20] = 0;
            }
	}else data->tickCount[20] = data->tick[20];
	if(ljoy_h>50){
	    data->tickCount[21]++;
        if(data->tickCount[21] > data->tick[21]) 
            {
			data->L3_RIGHT=ljoy_h;
            data->tickCount[21] = 0;
            }
	}else data->tickCount[21] = data->tick[21];
	
	int ljoy_v = data->buttons.ljoy_v - 128;
	if (ljoy_v <-50){
	    data->tickCount[22]++;
        if(data->tickCount[22] > data->tick[22]) 
            {
			data->L3_UP=-ljoy_v;
            data->tickCount[22] = 0;
            }
	}else data->tickCount[22] = data->tick[22];
	if(ljoy_v>50){
	    data->tickCount[23]++;
        if(data->tickCount[23] > data->tick[23]) 
            {
			data->L3_DOWN=ljoy_v;
            data->tickCount[23] = 0;
            }
	}else data->tickCount[23] = data->tick[23];

    }

void SysPadResetControl(padData *data)
    {
    int i;
    
    for(i=0;i<24;i++)
        {
       	data->tick[i] = 0;
       	data->tickCount[i] = 0;
        }

    // Todos los botones a off
   	data->LEFT     = 0;
   	data->DOWN     = 0;
   	data->RIGHT    = 0;
   	data->UP       = 0;
   	data->START    = 0;
   	data->R3       = 0;
   	data->L3       = 0;
   	data->SELECT   = 0;
   	data->SQUARE   = 0;
   	data->CROSS    = 0;
   	data->CIRCLE   = 0;
   	data->TRIANGLE = 0;
   	data->R1       = 0;
   	data->L1       = 0;
   	data->R2       = 0;
   	data->L2       = 0;
	data->R3_LEFT  = 0;
	data->R3_RIGHT = 0;
	data->R3_UP	   = 0;
	data->R3_DOWN  = 0;
	data->L3_LEFT  = 0;
	data->L3_RIGHT = 0;
	data->L3_UP	   = 0;
	data->L3_DOWN  = 0;	
    }
    
void SysPadSetControl(padData *data,int button,int iterator)
    {
    int id = getBitButton(button);
    data->tick[id] = iterator;
    data->tickCount[id] = 0;
    }

int getBitButton(int button)
    {
    switch(button)
        {
        case PAD_LEFT:     return  0; break;
       	case PAD_DOWN:     return  1; break;
       	case PAD_RIGHT:    return  2; break;
       	case PAD_UP:       return  3; break;
       	case PAD_START:    return  4; break;
       	case PAD_R3:       return  5; break;
       	case PAD_L3:       return  6; break;
       	case PAD_SELECT:   return  7; break;
       	case PAD_SQUARE:   return  8; break;
       	case PAD_CROSS:    return  9; break;
       	case PAD_CIRCLE:   return 10; break;
       	case PAD_TRIANGLE: return 11; break;
       	case PAD_R1:       return 12; break;
       	case PAD_L1:       return 13; break;
       	case PAD_R2:       return 14; break;
       	case PAD_L2:       return 15; break;
       	case PAD_R3_LEFT:  return 16; break;
	    case PAD_R3_RIGHT: return 17; break;
       	case PAD_R3_UP:    return 18; break;
       	case PAD_R3_DOWN:  return 19; break;
       	case PAD_L3_LEFT:  return 20; break;
	    case PAD_L3_RIGHT: return 21; break;
       	case PAD_L3_UP:    return 22; break;
       	case PAD_L3_DOWN:  return 23; break;
       	}
    return 0;
    }


void SysPadSetEngine(padData *data,int SmallEngine, int BigEngine)
    {
    actAlign[0] = SmallEngine;
    actAlign[1] = BigEngine;
    actAlign[2] = 0xff;
    actAlign[3] = 0xff;
    actAlign[4] = 0xff;
    actAlign[5] = 0xff;

   padSetActDirect(data->port, data->slot, actAlign);
    }


#include <tamtypes.h>
#include <kernel.h>
#include <sifrpc.h>
#include <loadfile.h>
#include <stdio.h>

#include "libpad.h"



/*
 * Local functions
 */

/*
 * loadModules()
 */
void loadModules(void)
{
    int ret;

	if(getMediaMode(0) != MODE_MC0 && getMediaMode(0) != MODE_MC1){
    //ret = SifLoadModule("rom0:XSIO2MAN", 0, NULL);
	    SifInitRpc(0);
	ret=SifExecModuleBuffer(&freesio2_irx, size_freesio2_irx, 0, NULL,  NULL);
    if (ret < 0) {
        printf("sifLoadModule sio failed: %d\n", ret);
        SleepThread();
    }    
	}

    //ret = SifLoadModule("rom0:XPADMAN", 0, NULL);
	ret=SifExecModuleBuffer(&freepad_irx, size_freepad_irx, 0, NULL,  NULL);

    if (ret < 0) {
        printf("sifLoadModule pad failed: %d\n", ret);
        SleepThread();
    }
}

/*
 * waitPadReady()
 */
int waitPadReady(int port, int slot)
{
    int state;
    int lastState;
    char stateString[16];

    state = padGetState(port, slot);
    lastState = -1;
    while((state != PAD_STATE_STABLE) && (state != PAD_STATE_FINDCTP1)) {
        if (state != lastState) {
            padStateInt2String(state, stateString);
            printf("Please wait, pad(%d,%d) is in state %s\n", 
                       port, slot, stateString);
        }
        lastState = state;
        state=padGetState(port, slot);
    }
    // Were the pad ever 'out of sync'?
    if (lastState != -1) {
        printf("Pad OK!\n");
    }
    return 0;
}


/*
 * initializePad()
 */
int initializePad(int port, int slot)
{

    int ret;
    int modes;
    int i;

    waitPadReady(port, slot);

    // How many different modes can this device operate in?
    // i.e. get # entrys in the modetable
    modes = padInfoMode(port, slot, PAD_MODETABLE, -1);
    printf("The device has %d modes\n", modes);

    if (modes > 0) {
        printf("( ");
        for (i = 0; i < modes; i++) {
            printf("%d ", padInfoMode(port, slot, PAD_MODETABLE, i));
        }
        printf(")");
    }

    printf("It is currently using mode %d\n", 
               padInfoMode(port, slot, PAD_MODECURID, 0));

    // If modes == 0, this is not a Dual shock controller 
    // (it has no actuator engines)
    if (modes == 0) {
        printf("This is a digital controller?\n");
        return 1;
    }

    // Verify that the controller has a DUAL SHOCK mode
    i = 0;
    do {
        if (padInfoMode(port, slot, PAD_MODETABLE, i) == PAD_TYPE_DUALSHOCK)
            break;
        i++;
    } while (i < modes);
    if (i >= modes) {
        printf("This is no Dual Shock controller\n");
        return 1;
    }

    // If ExId != 0x0 => This controller has actuator engines
    // This check should always pass if the Dual Shock test above passed
    ret = padInfoMode(port, slot, PAD_MODECUREXID, 0);
    if (ret == 0) {
        printf("This is no Dual Shock controller??\n");
        return 1;
    }

    printf("Enabling dual shock functions\n");

    // When using MMODE_LOCK, user cant change mode with Select button
    padSetMainMode(port, slot, PAD_MMODE_DUALSHOCK, PAD_MMODE_LOCK);

    waitPadReady(port, slot);
    printf("infoPressMode: %d\n", padInfoPressMode(port, slot));

    waitPadReady(port, slot);        
    printf("enterPressMode: %d\n", padEnterPressMode(port, slot));

    waitPadReady(port, slot);
    actuators = padInfoAct(port, slot, -1, 0);
    printf("# of actuators: %d\n",actuators);

    if (actuators != 0) {
        actAlign[0] = 0;   // Enable small engine
        actAlign[1] = 1;   // Enable big engine
        actAlign[2] = 0xff;
        actAlign[3] = 0xff;
        actAlign[4] = 0xff;
        actAlign[5] = 0xff;

        waitPadReady(port, slot);
        printf("padSetActAlign: %d\n", 
                   padSetActAlign(port, slot, actAlign));
    }
    else {
        printf("Did not find any actuators.\n");
    }

    waitPadReady(port, slot);

    return 1;
}

