/***************************************************************
/  Ifcaro3D - Preview                                          /
/                                                              /
/  Creado por Ifcaro <taslokooo@gmail.com>                     /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Contiene codigo de ps2game:                                 /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include "Ifcaro3D.h"

#define MAX_SOUNDBANK  64
#define MAX_MUSICBANK  2

unsigned char bankSound[MAX_SOUNDBANK];
unsigned char bankMusic[MAX_MUSICBANK];
int canalesMP3[2] = {-1,-1};
int sonandoMP3 = 0;
int duracionSonido[MAX_SOUNDBANK];

extern u8 *freesd_irx;
extern int size_freesd_irx;

extern u8 *audio_irx;
extern int size_audio_irx;

//void SysInitSFX(char *audioirx)
void SysInitSFX()
	{
    //char fname[FIO_PATH_MAX];

    /* -- */
	//SifInitRpc(0);
	SifLoadModule("rom0:LIBSD", 0, 0);
	//SifExecModuleBuffer(&freesd_irx, size_freesd_irx, 0, NULL,  NULL);

	//getMediaName(&fname[0], audio_irx);
    //SifLoadModule(fname, 0, 0);
	
	SifExecModuleBuffer(&audio_irx, size_audio_irx, 0, NULL,  NULL);

	SoundInit();
	InitMP3(1);

	PCMSilence();
	PCMInit(44100,2);
	PCMVolume(0x4fff,0x4fff);
	/* --- */
    SysResetSFX();
    }

void SysResetSFX()	
	{
    int i;

    // Cerramos MUSIC
    for(i=0;i<MAX_MUSICBANK;i++) 
    	{
        CloseMP3(i);
    	bankMusic[i] = 0;
    	}    

    // Cerramos Sound
    for(i=0;i<MAX_SOUNDBANK;i++) 
    	{
    	bankSound[i] = 0;
    	}   	

    // liberamos todos los Vag
    SoundReleaseAllVag();

    // hacemos un reset
    ResetMP3();
	}    

void SysTickSFX()
    {
	
    // Music
	if(sonandoMP3==1){
		ReadAndDecodeMP3();
		SendSamplesMP3();
	}
	// Sound
    SoundLoop();
    }

// -----------------------------------------------------
// --> MP3
// -----------------------------------------------------

int LoadMusic(char *filename)
    {
    char fname[FIO_PATH_MAX];
    int i,id;
	int id3v2=0;
	char cab[8];

    // buscamos in id libre para los canales de mp3
    id = -1;
    for(i=0;i<MAX_MUSICBANK;i++)
        if (bankMusic[i] == 0)
            {
            id=i;
            break;
            }
    if (id==-1) 
    	{
        printf("SysLoadMP3 Error: Sin espacio de entorno\n");
        return -1;
    	}   	
    // ----------------------------------------------

    // ya estamos listos para leer el archivo
    getMediaName(&fname[0], filename);

	int fd=fioOpen(fname, O_RDONLY);
	fioRead(fd, cab, 8);
	fioClose(fd);
	if ((!strncmp(cab,"ID3",3)) && cab[7]!=0)id3v2=1;
	printf("Abriendo : %s ID3v2: %d\n",fname, id3v2);
    canalesMP3[id] = OpenMP3(fname);
	if(id3v2==1)SkipTimeMP3(1);
    bankMusic[id] = 1; // canal en uso
    return id;
    }
	
int LoadMusicC(char *filename, int size)
    {
    int i,id;

    // buscamos in id libre para los canales de mp3
    id = -1;
    for(i=0;i<MAX_MUSICBANK;i++)
        if (bankMusic[i] == 0)
            {
            id=i;
            break;
            }
    if (id==-1) 
    	{
        printf("SysLoadMP3 Error: Sin espacio de entorno\n");
        return -1;
    	}   	
    // ----------------------------------------------

    // ya estamos listos para leer el archivo
    //getMediaName(&fname[0], filename);
    canalesMP3[id] = MemOpenMP3(filename, size);

    bankMusic[id] = 1; // canal en uso
    return id;
    }

void PlayMusic(int id,int loop)
	{
	sonandoMP3=1;
    RepeatMP3(id, loop);
    }    
	
void PauseMusic()
	{
	sonandoMP3=0;
    }    
	
void StopMusic()
	{
	sonandoMP3=0;
	ResetMP3();
    }  

int MusicPlaying(){
	sonandoMP3=!EofMP3(0);
	return sonandoMP3;
}

void FreeMusic(int id){
	CloseMP3(id);
    bankMusic[id] = 0;
}

// -----------------------------------------------------
// --> VAG
// -----------------------------------------------------

int LoadSound(char *filename, int duracion)
    {
    char fname[FIO_PATH_MAX];
    int i;
    int id;

    // buscamos in id libre dentro del banko de sonidos
    id = -1;
    for(i=0;i<MAX_SOUNDBANK;i++)
        if (bankSound[i] == 0)
            {
            id=i;
            break;
            }

    if (id==-1)
    	{
        printf("SysLoadVag Error: Sin espacio de entorno\n");
        return -1;
    	}   	
    // ----------------------------------------------
    
    getMediaName(&fname[0], filename);
    if(SoundLoadVag(id,fname))
    	{
        printf("SysLoadVag Error: SoundLoadVag error\n");
        return -1;
    	}   	

    bankSound[id] = 1; // marcamos que estamos usando esta pos
	duracionSonido[id]=duracion;
    return id;         // y la devolvemos
    }
	
int LoadSoundC(char *filename, int size, int duracion)
    {
    //char fname[FIO_PATH_MAX];
    int i;
    int id;

    // buscamos in id libre dentro del banko de sonidos
    id = -1;
    for(i=0;i<MAX_SOUNDBANK;i++)
        if (bankSound[i] == 0)
            {
            id=i;
            break;
            }

    if (id==-1)
    	{
        printf("SysLoadVag Error: Sin espacio de entorno\n");
        return -1;
    	}   	
    // ----------------------------------------------
    
    //getMediaName(&fname[0], filename);
    if(SoundLoadMemVag(id, filename+384, size-384))
    	{
        printf("SysLoadVag Error: SoundLoadVag error\n");
        return -1;
    	}   	
    bankSound[id] = 1; // marcamos que estamos usando esta pos
	duracionSonido[id]=duracion;
    return id;         // y la devolvemos
    }


void PlaySound(int id)
    {

    // PlayVoice(sample,frec,delaytime,time,voll,volr,ADSR)
    // Reproduce un VAG en el IOP. (asignacion automatica de canal)
    // sample-> ndice al sample (0 a 255)
    // frec-> frecuencia central en Herzios del Vag
    // delaytime-> tiempo en ms de retardo antes de ejecutar el Vag (pasos de 10ms)
    // time-> tiempo en ms de duracion del Vag (pasos de 10ms)
    // voll,vollr-> volumen canal izquierdo y derecho. rango : 0 a 0x7fff
    // ADSR ->Efecto de audio, 0=sin efectos
    //  BIT 31-29 Sustain rate mode. Modes: 000->Linear Increase, 010 Linear Decrease,
    //                              100->Pseudo Exp Increase, 110 Exponential Decrease
    //  BIT 28-22 Sustain Rate
    //  BIT 21    Release Rate Mode 0-> Linear Decrease Mode, 1 Exponential Decrease Mode
    //  BIT 20-16 Release Rate
    //  BIT 15    Attack Rate Mode 0-> Linear Increase, 1 Pseudo Exponential Increase
    //  BIT 14-8  Attack Rate
    //  BIT 7-4   Decay Rate
    //  BIT 3-0   Sustain Level
    //
    // ret-> ==0 Sin Error !=0 Error

    if (id>=0 && id<MAX_SOUNDBANK)
        PlayVoice(id,11025,0,duracionSonido[id],0x7fff,0x7fff,0);
    }

